
package com.btc.ep.base.dal.impl;

import java.util.Collection;

import com.btc.ep.base.bl.ModelElement;
import com.btc.ep.base.bl.impl.ModelElementImpl;

public interface BaseRepository<T extends ModelElement> {

    public T find(String uid);

    public <E extends ModelElementImpl> Collection<E> findAll(Class<E> clazz);

    public T update(T dmo);

    public Collection<T> update(Collection<T> dmos);

    public void remove(T dmo);

    public void remove(Collection<T> dmos);

    public void removeImpl(Collection<? extends ModelElementImpl> dmos);

    public boolean save();

    public boolean revert();

    public boolean clearDatabase();
}
