package com.btc.ep.base.dal.tests.it;

import java.util.concurrent.atomic.AtomicInteger;

import com.btc.ep.core.Services;
import com.btc.ep.dal.persist.PersistenceManager;
import com.btc.ep.dal.persist.impl.PersistenceService;

public class BaseTest {

    private static PersistenceService persistenceService;

    protected long startTime;

    protected AtomicInteger counter = new AtomicInteger(1);

    protected void deleteDatabase() {
        getPersistenceService().updateQuery("DELETE FROM Object"); // delete whole database
    }

    public PersistenceService getPersistenceService() {
        if (persistenceService == null) {
            PersistenceManager persistenceManager = Services.get(PersistenceManager.class);
            persistenceService = persistenceManager.getPersistenceService();
        }
        return persistenceService;
    }

    public static void destroyPersistenceService() {
        PersistenceManager persistenceManager = Services.get(PersistenceManager.class);
        persistenceService = null;
        persistenceManager.close();
    }

    private String convertMemory(long value) {
        return "" + value / 1024 / 1000 + "MB";
    }

    public void memoryInfo() {

        long max = Runtime.getRuntime().maxMemory();
        long free = Runtime.getRuntime().freeMemory();
        long total = Runtime.getRuntime().totalMemory();

        System.out.println("max: " + convertMemory(max));
        System.out.println("free: " + convertMemory(free));
        System.out.println("total: " + convertMemory(total));
        System.out.println("used: " + convertMemory((total - free)));
        System.out.println("");
    }

    public void remarkTime() {
        startTime = System.currentTimeMillis();
    }

    public void printTime(String usecase) {
        System.out.println(usecase + " time: " + (System.currentTimeMillis() - startTime));
    } 

}
