package com.btc.ep.base.dal.tests.it;

import java.io.File;
import java.util.Collection;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import com.btc.ep.base.bl.ModelElement;
import com.btc.ep.base.bl.Profile;
import com.btc.ep.base.bl.impl.ProfileImpl;
import com.btc.ep.base.dal.impl.BaseRepository;
import com.btc.ep.base.dal.internal.BaseRepositoryImpl;

public class IT_DALSaveAndLoadTest extends BaseTest {

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		destroyPersistenceService();
	}

	@Before
	public void setUp() throws Exception {
		deleteDatabase();
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void saveProfileAndLoadProfileAndComparingProfilesTest()
			throws Exception {

		BaseRepository<ModelElement> baseRepository = new BaseRepositoryImpl();

		Profile profile = new ProfileImpl();

		profile.setFilePath(new File("abc.txt"));
		profile.setName("profile");

		getPersistenceService().persist(profile);
		baseRepository.save();

		profile = getPersistenceService().getModelElementByQuery("select p from ProfileImpl p", ProfileImpl.class);
		profile.setName("anders");

		profile = getPersistenceService().getModelElementByQuery("select p from ProfileImpl p", ProfileImpl.class);
		getPersistenceService().remove(profile);

		baseRepository.save();
	}

}
