package com.btc.ep.base.dal.tests.it;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import com.btc.ep.base.bl.ModelElement;
import com.btc.ep.base.bl.TCStep;
import com.btc.ep.base.bl.impl.TCStepImpl;
import com.btc.ep.base.dal.impl.BaseRepository;
import com.btc.ep.base.dal.internal.BaseRepositoryImpl;

public class SetAndRemoveIssue extends BaseTest {

	private static final String VECTOR_ID = "v-id";
	private static final long STEP_NUMBER = 0L;

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		destroyPersistenceService();
	}

	@Before
	public void setUp() throws Exception {
		deleteDatabase();
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void test() {

		BaseRepository<ModelElement> baseRepository = new BaseRepositoryImpl();

		TCStep a = new TCStepImpl(VECTOR_ID, STEP_NUMBER);
		getPersistenceService().persist(a);
		baseRepository.save();

		a = findStepBefore(VECTOR_ID, STEP_NUMBER + 1);
		a.setStepDuration(2);

		a = findStepWithStepNumber(VECTOR_ID, STEP_NUMBER);
		getPersistenceService().remove(a);

		baseRepository.save();

		System.out.println("ok");
	}

	public TCStep findStepBefore(String vectorID, long stepNumber) {
		String sql = "SELECT s FROM " + TCStepImpl.class.getSimpleName()
				+ " s WHERE s.vectorID == ?1 AND s.stepNumber < ?2 ORDER BY s.stepNumber DESC";
		return getPersistenceService().getModelElementByQuery(sql, TCStepImpl.class, vectorID, stepNumber);
	}

	public TCStep findStepWithStepNumber(String vectorID, long stepNumber) {
		String sql = "SELECT s FROM " + TCStepImpl.class.getSimpleName()
				+ " s WHERE s.vectorID == ?1 AND s.stepNumber == ?2";
		return getPersistenceService().getModelElementByQuery(sql, TCStepImpl.class, vectorID, stepNumber);
	}
}
